#include "stdafx.h"
#include "nTalkDownloadFileJob.h"

const int MAX_RECEIVE_ERROR_INFO_LENGTH = 300;  //217
const int MIN_RECEIVE_RESULT_INFO_POS	= 10;	//5
const int MAX_RENAME_FILE_COUNT			= INT_MAX;

CNTalkDownloadFileJob::CNTalkDownloadFileJob(const CAtlString& strAgent, BOOL bSuspendOnCreate)
:CFDownloadJob(strAgent, bSuspendOnCreate)
{
	m_bRecvFirstBuffer = TRUE;
}

HANDLE CNTalkDownloadFileJob::_CreateLocalSaveFile()
{
	HANDLE hLocalFile = __super::_CreateLocalSaveFile();
	if (INVALID_HANDLE_VALUE == hLocalFile)
	{
		//Can not create File,
		TCHAR szLocalFilePath[_MAX_PATH] = {0};
		TCHAR szDrive[_MAX_DRIVE]  = {0};
		TCHAR szDir[_MAX_DIR] = {0};
		TCHAR szFileName[_MAX_FNAME] = {0};
		TCHAR szExt[_MAX_EXT] = {0};
        TCHAR szFilePrefix[_MAX_FNAME] = {0};

		_tsplitpath_s(m_strLocalFilePath, szDrive, szDir, szFileName, szExt);
		
		int nIndex = 1;
        if(_SpitFileNameAndIndex(szFileName, szFilePrefix, _countof(szFilePrefix), nIndex))
        {
            StringCchCopy(szFileName, _countof(szFileName), szFilePrefix);
            nIndex++;
        }

		CString strFileName;
		while (nIndex <= MAX_RENAME_FILE_COUNT && INVALID_HANDLE_VALUE == hLocalFile)
		{
			strFileName.Format(TEXT("%s(%d)"), szFileName, nIndex);
			_tmakepath_s(szLocalFilePath, szDrive, szDir, strFileName, szExt);
			hLocalFile = ::CreateFile(szLocalFilePath, 
				GENERIC_WRITE, 
				0, 
				NULL,
				CREATE_NEW, 
				FILE_ATTRIBUTE_NORMAL, 
				NULL);
			if (INVALID_HANDLE_VALUE != hLocalFile)
			{
				//change file path
				m_strLocalFilePath = szLocalFilePath;
				break;
			}
			nIndex++;
		}
	}

	return hLocalFile;
}

BOOL CNTalkDownloadFileJob::_SpitFileNameAndIndex(LPCTSTR pszFileName, LPTSTR pszFilePrefix, DWORD dwMaxSize, int& nIndex)
{
    BOOL bRet = FALSE;

    FTLASSERT(pszFileName);
    int nStrLength = lstrlen(pszFileName);
    FTLASSERT(nStrLength > 0 && nStrLength < dwMaxSize);
    if (nStrLength > 0 && nStrLength < dwMaxSize)
    {
        StringCchCopy(pszFilePrefix, dwMaxSize, pszFileName);

        LPTSTR pszCloseParenthesis = NULL;
        LPTSTR pszOpenParenthesis = NULL;
        if(_T(')') == pszFilePrefix[nStrLength - 1])
        {
            pszCloseParenthesis = pszFilePrefix + nStrLength - 1;
        }
        if (pszCloseParenthesis)
        {
            pszOpenParenthesis = StrRChr(pszFilePrefix, pszCloseParenthesis, _T('('));
        }
        if (pszCloseParenthesis && pszOpenParenthesis && pszOpenParenthesis < pszCloseParenthesis)
        {
            //have (xxx)
            *pszCloseParenthesis = NULL;    //end string at close parenthesis

            BOOL bAllNumber = TRUE;     //check is all number
            LPCTSTR pszCheckIndex = &pszOpenParenthesis[1];

            while (*pszCheckIndex)
            {
                if (*pszCheckIndex < _T('0') || *pszCheckIndex > _T('9'))
                {
                    //is not number
                    bAllNumber = FALSE;
                    break;
                }
                pszCheckIndex++;
            }

            if (bAllNumber)
            {
                nIndex = StrToInt(&pszOpenParenthesis[1]);
                *pszOpenParenthesis = NULL;
                bRet = TRUE;
            }
        }
    }

    return bRet;
}


BOOL CNTalkDownloadFileJob::_CheckInternetBuffer(LPBYTE pBuffer, LONG nCount, CAtlString& strResultInfo)
{
	BOOL bRet = TRUE;
	if (m_bRecvFirstBuffer)
	{
		//just check the first buffer
		m_bRecvFirstBuffer = FALSE;
	
		if (nCount <= MAX_RECEIVE_ERROR_INFO_LENGTH)
		{
			//Error Info is UTF8, 
			LPCSTR pszInfo = (LPCSTR)pBuffer;
			LPCSTR pszResultString = "{\"Result\":\"";   // {"Result":"
			int nCompareLength = strlen(pszResultString);
			FTLASSERT(nCompareLength == 11); 

			//because the buffer maybe binary file data, so can not use strstr to check the "Result"
			INT nPos = 0;
			while ( nPos++ < nCount && *pszInfo)
			{
				if (*pszInfo == '{' && nPos <= MIN_RECEIVE_RESULT_INFO_POS)
				{
					if (memcmp(pszInfo, pszResultString, nCompareLength) == 0)
					{
						//find Result String, so this maybe Result Json info
						SetLastError(ERROR_INVALID_ADDRESS);
						FTLTRACE(TEXT("Find Result String in _CheckInternetBuffer: %s\n"), FTL::CFConversion(CP_UTF8).UTF8_TO_TCHAR(pszInfo));
						bRet = FALSE;
						break;
					}
				}
				pszInfo++;
			}
		}
	}
	
	return bRet;
}
